{ lib, rustPlatform, makeWrapper, pkg-config, curl, nodejs }:

rustPlatform.buildRustPackage {
  pname = "make-npm-cacache";
  version = (lib.importTOML ./Cargo.toml).package.version;

  src = lib.cleanSourceWith {
    src = ./.;
    filter = name: type:
      let
        name' = builtins.baseNameOf name;
      in
      name' != "default.nix" && name' != "target";
  };

  cargoLock.lockFile = ./Cargo.lock;

  nativeBuildInputs = [ makeWrapper pkg-config ];
  buildInputs = [ curl ];

  postInstall = ''
    wrapProgram "$out/bin/make-npm-cacache" --prefix PATH : ${lib.makeBinPath [ nodejs ]}
  '';

  meta = with lib; {
    description = "Converts dependency files into a format that npm can understand";
    maintainers = with maintainers; [ lilyinstarlight winter ];
    license = licenses.mit;
  };
}
